package com.enoram.restify;

import org.junit.BeforeClass;
import org.junit.Test;

import com.enoram.restify.client.Comment;
import com.enoram.restify.server.GreetingServiceImpl;
import com.enoram.restify.server.RestRequestContent;
import com.enoram.restify.server.guice.GuiceRestify;
import com.enoram.restify.server.guice.GwtServiceModule;
import com.google.gson.Gson;
import com.google.inject.Guice;
import com.google.inject.Injector;
import com.google.inject.Key;
import com.google.inject.name.Names;

public class TestProcessCall extends BaseTest{

	
	private final static String API_NAMED = GuiceRestify.getApiNamed(GreetingServiceImpl.class);
	private final static String METHOD_NAMED = "register";
	
	
	static Injector injector;
	
	
	//private RestServiceTest restService;
	
	@BeforeClass
	public static void  setupOnce(){
		
		injector = Guice.createInjector(

				new GwtServiceModule(),
				new RestModuleTest()
				);
		
		
	}
	
	private RestServiceTest getRestService(String uriPath){
		return injector.getInstance(Key.get(RestServiceTest.class, Names.named(uriPath)));
	}
	
	//@Test
	public void testProcessCall() throws Throwable{
		RestServiceTest restService = getRestService(API_NAMED);
		
		RestRequestContent reqContent = createRestRequestContent(API_NAMED, METHOD_NAMED, "name=test"+System.currentTimeMillis());
		restService.doPost(reqContent);
		
		String response = restService.getResponse();
		
		System.out.println(response);
		
	}
	@Test
	public void testGreetServer() throws Throwable{
		RestServiceTest restService = getRestService(API_NAMED);
		
		RestRequestContent reqContent = createRestRequestContent(API_NAMED, 
				"hello", "greeting=Hi+from+"+System.currentTimeMillis());
		restService.doPost(reqContent);
		
		String response = restService.getResponse();
		
		System.out.println(response);
	}
	
	//@Test
	public void testAddComment() throws Throwable{
		RestServiceTest restService = getRestService(API_NAMED);
		
		Comment comment = new Comment("Comment of "+System.currentTimeMillis());
		
		Gson gson = new Gson();
		String json = gson.toJson(comment);
		
		RestRequestContent reqContent = createRestRequestContent(API_NAMED, 
				"greet/comment", "greetId=1&comment="+json);
		restService.doPost(reqContent);
		
		String response = restService.getResponse();
		
		System.out.println(response);
	}

	

	
}
