package com.enoram.restify.server;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;

import com.google.gwt.user.client.rpc.IncompatibleRemoteServiceException;
import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.SerializationException;
import com.google.gwt.user.server.rpc.RPC;
import com.google.gwt.user.server.rpc.RPCRequest;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Singleton;

@Singleton
public class GwtGuiceRemoteServlet extends RemoteServiceServlet {
	/**
	 * 
	 */
	private static final long serialVersionUID = -3627364979814949670L;

	@Inject
	private Injector injector;

	//private WebApplicationContext webAppContext;
	
	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		 
	}
	
	
	
	
	private String getVersionNo() {
		 String versionReturn ="";
//
//		 try {
//		 Session sess = Sessions.getCurrent();
//		 HttpSession hses = (HttpSession) sess.getNativeSession();
//		 ServletContext sCon = hses.getServletContext();
//		 Properties prop = new Properties();
//		 prop.load(sCon.getResourceAsStream("/META-INF/MANIFEST.MF"));
//
//		 String appVersion = prop.getProperty("version");
//		 String appDate = prop.getProperty("id");
//		 versionReturn = "Version: " + appVersion + " (" + appDate +")";
//
//		 } catch (IOException ex) {
//		 versionReturn = "No version available.";
//		 return versionReturn;
//
//		 }
//		 return versionReturn;
		 
		 return versionReturn;
		 }	
	
	@Override
	public String processCall(String payload) throws SerializationException {
		try {

			
			RPCRequest req = RPC.decodeRequest(payload, null, this);

			RemoteService service = getServiceInstance(req.getMethod()
					.getDeclaringClass());

			return RPC.invokeAndEncodeResponse(service, req.getMethod(),
					req.getParameters(), req.getSerializationPolicy());
		} catch (IncompatibleRemoteServiceException ex) {
			log("IncompatibleRemoteServiceException in the processCall(String) method.",
					ex);
			return RPC.encodeResponseForFailure(null, ex);
		}finally{
			
	
			
		}
	}

	@SuppressWarnings({ "unchecked" })
	private RemoteService getServiceInstance(Class serviceClass) {
		return (RemoteService) injector.getInstance(serviceClass);
	}
}