package com.enoram.restify.server;

import com.google.gson.Gson;

public class ObjectReturnedParamCallBack implements ParamCallBack{
	private Object object;
	private RestParam restParam;
	private RestRequestContent requestContent;

	public ObjectReturnedParamCallBack(Object object, RestRequestContent requestContent) {
		super();
		this.object = object;
		this.requestContent = requestContent;
		this.restParam = requestContent.getRestParam();
	}
	
	@Override
	public void perform(String type, String pname) {
		try {

			object = restParam.deserializeValue(type, pname);


		} catch (Exception e) {
			throw new RuntimeException("Parameter " + pname
					+ " of is of an unknown value '" + type + "'", e);
		}
	}

	public Object getResult() {
		return object;
	}

	@Override
	public void performObject(String type, String pname) {
		Class<?> clazz;
		try {
			clazz = Class.forName(type);
			Gson gson = new Gson();
			object = gson.fromJson(requestContent.getContent(),
					clazz);
		} catch (ClassNotFoundException e) {	
			e.printStackTrace();
			throw new RuntimeException(e);
		}


		
	}

	
	
}
