package com.enoram.restify.server;

import java.io.Serializable;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

/**
 * Object to represent REST method, api name and params.
 * 
 * @author Nathan
 *
 */
public class RestRequestInfo implements Serializable{

	private static final long serialVersionUID = 835251618166848626L;
	private String apiNamed;
	//key is methodPath
	private Map<String, Method> methods = new HashMap<String, Method>() ;
	private Map<String, String[]>  params = new HashMap<String, String[]>();
	
	private String content;
	
	public RestRequestInfo(String apiNamed) {
		super();
		this.apiNamed = apiNamed;
	}


	public String getContent() {
		return content;
	}
	public void setContent(String content) {
		this.content = content;
	}
	
	public boolean isEmptyApiNamed(){
		return getApiNamed() ==null || getApiNamed().isEmpty();
	}

	
	@Override
	public String toString() {
		
		return ""+apiNamed +"|";
	}

	public String getApiNamed() {
		return apiNamed;
	}



	public Map<String, Method> getMethods() {
		return methods;
	}

	public void setMethods(Map<String, Method> methods) {
		this.methods = methods;
	}

	public Map<String, String[]> getParams() {
		return params;
	}

	public void setParams(Map<String, String[]> params) {
		this.params = params;
	}

	
	
}
