package com.enoram.restify.server.restapi.gen;

import java.util.ArrayList;
import java.util.List;

import junit.framework.Assert;

import org.junit.BeforeClass;
import org.junit.Test;

import com.enoram.restify.RestApiClientTest;
import com.enoram.restify.client.GreetingService;
import com.google.inject.AbstractModule;
import com.google.inject.Guice;
import com.google.inject.Injector;
import com.google.inject.Module;
import com.google.inject.name.Names;

/**
 * A tester class to test basic GreetService REST API
 * 
 * @author Nathan
 * @see GreetingService
 * 
 */
public class TestGreetRestApiList extends BaseTestRestApi {

	static Injector injector;

	@BeforeClass
	public static void  setupOnce(){
		
		BASE_MODULES.addAll(setupRestApiClientModules());
		injector = Guice.createInjector(BASE_MODULES); 
		
	}

	protected static List<Module> setupRestApiClientModules(){
		List<Module> modules = new ArrayList<Module>();
		
		modules.add(new RestApiClientTest());
		
		modules.add( new AbstractModule() {
			
			@Override
			protected void configure() {
			
			
				bind(GreetRestApi.class).to(GreetRestApiTest.class);
				
				bind(String.class)
		        .annotatedWith(Names.named("test.host"))
		        .toInstance("http://localhost");
			}
			}
			);
		
		
		
		return modules;
	}

	private GreetRestApi getGreetRestApi() {
		return injector.getInstance(GreetRestApi.class);
	}


	@Test
	public void testGet(){
		String response = getGreetRestApi().getName(0);
		
		assertResponse(response);
	}
	

	@Test
	public void testGetList(){
		List list = getGreetRestApi().comments();
		
		
		
	}
	
	private void assertResponse(Object response) {
		System.out.println(response);

		Assert.assertTrue(response != null);
		Assert.assertTrue(!response.toString().contains("//EX"));
	}

}
